package io.github.thehrz.infernalmobs.config

import de.exlll.configlib.Configuration


@Configuration
class MainConfig {
    var chance = 20
    var mobChances = emptyMap<String, Int>()
    var levelChance = emptyMap<String, Int>()

    var namePrefix = "&fInfernal"
    var levelPrefixs = emptyMap<String, String>()

    var nameTags = NameTags(1, "&f<prefix> <mobName>")
    var nameTagsLevel = emptyMap<String, String>()

    var bossBarSettings = BossBarSettings(true, "&fLevel <mobLevel> &f<prefix> <mobName>", "PINK", "SOLID")

    var scoreBoard = ScoreBoard(enable = false, showHealth = true)
    var effectAllPlayerAttacks = true
    var enableParticles = true
    var enableDeathMessages = false
    var enableSpawnMessages = false
    var spawnMessageRadius = 64
    var noCreativeDrops = false

    var mobWorlds = listOf("<all>")
    var effectWorlds = listOf("<all>")
    var enabledMobs = emptyList<String>()
    var enabledCharmSlots = emptyList<Int>()
    var enabledAbilities = emptyList<String>()

    var mamaSpawnAmount = 3
    var vengeanceDamage = 6
    var berserkDamage = 3
    var moltenBurnLength = 5
    var gravityLevitateLength = 6
    var horseMountsHaveSaddles = true
    var armouredMountsHaveArmour = true
    var fireworkColour = FireworkColour(255, 10, 10)
    var enabledSpawnReasons = emptyList<String>()
    var mobParticles = listOf("lavaSpark:1:10")
    var mountFate = "nothing"

    var enabledMounts = emptyList<String>()
    var enabledRiders = emptyList<String>()
    var disabledBabyMobs = emptyList<String>()

    var minpowers = 3
    var maxpowers = 7
    var healthMultiplier = 4
    var healthByPower = false
    var healthByDistance = false
    var powerByDistance = false
    var healthToAdd = 5
    var powerToAdd = 1
    var xpMultiplier = 8
    var addDistance = 200
    var enableDrops = true
    var dropChance = 1
    var enableFarmingDrops = false
    var naturalSpawnHeight = 0

    var debug = false
    var items = emptyList<String>()

    @Configuration
    class NameTags(var level: Int = 1, var name: String = "&f<prefix> <mobName>")

    @Configuration
    class BossBarSettings(
        var enable: Boolean = true,
        var name: String = "&fLevel <mobLevel> &f<prefix> <mobName>",
        var color: String = "PINK",
        var style: String = "SOLID"
    )

    @Configuration
    class ScoreBoard(var enable: Boolean = false, var showHealth: Boolean = true)

    @Configuration
    class FireworkColour(var red: Int = 255, var green: Int = 10, var blue: Int = 10)

}