package io.github.thehrz.infernalmobs.handler

import io.github.thehrz.infernalmobs.InfernalMobs
import io.github.thehrz.infernalmobs.gui.GUI
import io.github.thehrz.infernalmobs.services.ConfigService
import io.github.thehrz.infernalmobs.services.InfernalMobService
import io.github.thehrz.infernalmobs.utils.EntityUtils
import io.github.thehrz.infernalmobs.utils.ItemUtils
import io.github.thehrz.infernalmobs.utils.ParticleUtils
import org.bukkit.*
import org.bukkit.attribute.Attribute
import org.bukkit.entity.*
import org.bukkit.inventory.ItemStack
import org.bukkit.potion.PotionEffect
import org.bukkit.potion.PotionEffectType
import org.koin.core.annotation.Single
import java.util.*
import java.util.logging.Level


@Single
class EffectHandle(
    private val configService: ConfigService,
    private val plugin: InfernalMobs,
    private val infernalMobService: InfernalMobService,
    private val magicHandler: MagicHandler,
    private val lootHandler: LootHandler,
    private val gui: GUI
) {
    var fertileList = mutableListOf<Player>()

    fun applyEffect() {
        //Check Players
        for (p in plugin.server.onlinePlayers) {
            val world = p.world
            if (configService.mainConfig.effectWorlds.contains(world.name)
                || configService.mainConfig.effectWorlds.contains("<all>")
            ) {
                val itemMap = HashMap<Int, ItemStack?>()
                for (i in configService.mainConfig.enabledCharmSlots) {
                    val item = p.inventory.getItem(i)
                    itemMap[i] = item
                }
                var ai = 100
                for (ar in p.inventory.armorContents) {
                    itemMap[ai] = ar
                    ai += 1
                }

                //for(int i = 0; i < 256; i++){
                if (configService.lootConfig.getConfigurationSection("potionEffects") != null) for (id in configService.lootConfig.getConfigurationSection(
                    "potionEffects"
                )!!
                    .getKeys(false)) if ((configService.lootConfig.getString("potionEffects.$id") != null) && (configService.lootConfig.getString(
                        "potionEffects.$id.attackEffect"
                    ) == null) && (configService.lootConfig.getString(
                        "potionEffects.$id.attackHelpEffect"
                    ) == null)
                ) {
                    val itemsPlayerHas = ArrayList<ItemStack?>()
                    for (neededItemIndex in configService.lootConfig.getIntegerList("potionEffects.$id.requiredItems")) {
                        val neededItem = lootHandler.getItem(neededItemIndex)
                        for ((key, check) in itemMap) {
                            try {
                                if ((neededItem!!.itemMeta == null) || (check!!.itemMeta.displayName == neededItem.itemMeta.displayName)) {
                                    if (check!!.type == neededItem.type) {
                                        //if ((neededItem.getType().getMaxDurability() > 0) || ((Damageable)check).getDamage() == (((Damageable)neededItem).getDamage())) {
                                        if (!ItemUtils.isArmor(neededItem) || key >= 100) itemsPlayerHas.add(neededItem)
                                        //}
                                        //}
                                    }
                                }
                            } catch (e: Exception) {
                                /**System.out.println("Error: " + e); */
                            }
                        }
                    }

                    if (itemsPlayerHas.size >= configService.lootConfig.getIntegerList("potionEffects.$id.requiredItems").size) {
                        applyEffects(p, id.toInt())
                    }
                }
            }
        }
        Bukkit.getServer().scheduler.scheduleSyncDelayedTask(
            plugin,
            { this.applyEffect() }, (10 * 20).toLong()
        )
    }

    fun doEffect(player: Player, mob: Entity, playerIsVictom: Boolean) {
        //Do Player Loot Effects
        if (!playerIsVictom) {
            //Get Player Item In Hand
            val itemUsed = player.inventory.itemInMainHand
            //Get Player Items
            val items = ArrayList<ItemStack>()
            for (i in 0..8) {
                val `in` = player.inventory.getItem(i)
                if (`in` != null) items.add(`in`)
            }
            for (ar in player.inventory.armorContents) items.add(ar)
            for (i in 0..255) {
                if (configService.lootConfig.getString("potionEffects.$i") != null) {
                    if (configService.lootConfig.getString("potionEffects.$i.attackEffect") != null) {
                        var effectsPlayer = true
                        if (configService.lootConfig.getString(
                                "potionEffects.$i.attackEffect",
                                "target"
                            ) == "target"
                        ) effectsPlayer =
                            false
                        for (neededItemIndex in configService.lootConfig.getIntegerList("potionEffects.$i.requiredItems")) {
                            val neededItem = lootHandler.getItem(neededItemIndex)
                            try {
                                if ((neededItem!!.itemMeta == null) || (itemUsed.itemMeta.displayName == neededItem.itemMeta.displayName)) {
                                    if (itemUsed.type == neededItem.type) {
                                        //if ((neededItem.getType().getMaxDurability() > 0) || (itemUsed.getDurability() == (neededItem.getDurability()))) {
                                        //Player Using Item
                                        if (effectsPlayer) {
                                            applyEffects(player, i)
                                        } else {
                                            if (mob is LivingEntity) applyEffects(mob, i)
                                        }
                                        //}
                                    }
                                }
                            } catch (e: Exception) {
                                /**System.out.println("Error: " + e); */
                            }
                        }
                    } else if (configService.lootConfig.getString("potionEffects.$i.attackHelpEffect") != null) {
                        var effectsPlayer = true
                        if (configService.lootConfig.getString(
                                "potionEffects.$i.attackHelpEffect",
                                "target"
                            ) == "target"
                        ) effectsPlayer = false
                        val itemsPlayerHas = ArrayList<ItemStack?>()
                        for (neededItemIndex in configService.lootConfig.getIntegerList("potionEffects.$i.requiredItems")) {
                            val neededItem = lootHandler.getItem(neededItemIndex)
                            for (check in items) {
                                try {
                                    if ((neededItem!!.itemMeta == null) || (check.itemMeta.displayName == neededItem.itemMeta.displayName)) {
                                        if (check.type == neededItem.type) {
                                            //if ((neededItem.getType().getMaxDurability() > 0) || (check.getDurability() == (neededItem.getDurability()))) {
                                            if (!itemsPlayerHas.contains(neededItem)) {
                                                itemsPlayerHas.add(neededItem)
                                            }
                                            //}
                                        }
                                    }
                                } catch (e: Exception) {
                                    /**System.out.println("Error: " + e); */
                                }
                            }
                        }
                        if (itemsPlayerHas.size >= configService.lootConfig.getIntegerList("potionEffects.$i.requiredItems").size) {
                            //Player Using Item
                            if (effectsPlayer) {
                                applyEffects(player, i)
                            } else {
                                if (mob is LivingEntity) applyEffects(mob, i)
                            }
                        }
                    }
                }
            }
        }
        //Do InfernalMob Effects
        try {
            val id = mob.uniqueId
            if (infernalMobService.idSearch(id) != -1) {
                val abilityList = infernalMobService.findMobAbilities(id)
                if ((!player.isDead) && (!mob.isDead)) {
                    for (ability in abilityList) {
                        magicHandler.doMagic(player, mob, playerIsVictom, ability, id)
                    }
                }
            }
        } catch (e: Exception) {
            /**System.out.println("Do Effect Error: " + e); */
        }
    }

    fun applyEffects(e: LivingEntity, effectID: Int) {
        val level = configService.lootConfig.getInt("potionEffects.$effectID.level")
        val name = configService.lootConfig.getString("potionEffects.$effectID.potion")
        if ((PotionEffectType.getByName(name!!) === PotionEffectType.HARM) || (PotionEffectType.getByName(
                name!!
            ) === PotionEffectType.HEAL)
        ) {
            e.addPotionEffect(PotionEffect(PotionEffectType.getByName(name!!)!!, 1, level - 1))
        } else {
            e.addPotionEffect(PotionEffect(PotionEffectType.getByName(name!!)!!, 400, level - 1))
        }

        val effect = configService.lootConfig.getString("potionEffects.$effectID.particleEffect")
        if (effect != null) {
            showEffectParticles(e, effect, 15)
        }
    }


    fun applyEatEffects(e: LivingEntity, effectID: Int) {
        for (s in configService.lootConfig.getList("consumeEffects.$effectID.potionEffects") as ArrayList<String>) {
            val split = s.split(":".toRegex()).dropLastWhile { it.isEmpty() }.toTypedArray()
            val name = split[0]
            val level = split[1].toInt()
            val time = split[2].toInt()
            if ((name.equals("fertility", ignoreCase = true)) && (e is Player)) {
                fertileList.add(e)
                Bukkit.getServer().scheduler.scheduleSyncDelayedTask(
                    plugin,
                    { fertileList.remove(e) }, (time * 20).toLong()
                )
            } else e.addPotionEffect(PotionEffect(PotionEffectType.getByName(name)!!, time * 20, level - 1))
        }
        if (e is Player) e.sendMessage(
            configService.lootConfig.getString(
                "consumeEffects.$effectID.message"
            )!!
                .replace("&", "§")
        )
    }

    private fun showEffectParticles(p: Entity, e: String, time: Int) {
        displayEffect(p.location, e)
        val nt = time - 1
        if (time > 0) {
            Bukkit.getServer().scheduler.scheduleSyncDelayedTask(
                plugin,
                { showEffectParticles(p, e, nt) }, 20L
            )
        }
    }

    private fun displayEffect(l: Location, effect: String = infernalMobService.effect) {
        //Get Effect and Datas
        val split = effect.split(":".toRegex()).dropLastWhile { it.isEmpty() }.toTypedArray()

        val name = split[0]
        val data1 = split[1].toInt()
        val data2 = split[2].toInt()
        try {
            var f = "FLAME"
            when (name) {
                "potionBrake" -> f = Particle.SPELL.toString()
                "smoke" -> f = Particle.SMOKE_NORMAL.toString()
                "blockBrake" -> f = Particle.BLOCK_CRACK.toString()
                "hugeExplode" -> f = Particle.EXPLOSION_HUGE.toString()
                "angryVillager" -> f = Particle.VILLAGER_ANGRY.toString()
                "cloud" -> f = Particle.CLOUD.toString()
                "criticalHit" -> f = Particle.CRIT.toString()
                "mobSpell" -> f = Particle.SPELL_MOB.toString()
                "enchantmentTable" -> f = Particle.ENCHANTMENT_TABLE.toString()
                "ender" -> f = Particle.PORTAL.toString()
                "explode" -> f = Particle.EXPLOSION_NORMAL.toString()
                "greenSparkle" -> f = Particle.VILLAGER_HAPPY.toString()
                "heart" -> f = Particle.HEART.toString()
                "largeExplode" -> f = Particle.EXPLOSION_LARGE.toString()
                "splash" -> f = Particle.WATER_SPLASH.toString()
                "largeSmoke" -> f = Particle.SMOKE_LARGE.toString()
                "lavaSpark" -> f = Particle.LAVA.toString()
                "magicCriticalHit" -> f = Particle.CRIT_MAGIC.toString()
                "noteBlock" -> f = Particle.NOTE.toString()
                "tileDust" -> f = Particle.BLOCK_DUST.toString()
                "colouredDust" -> f = Particle.REDSTONE.toString()
                "flame" -> f = Particle.FLAME.toString()
                "witchMagic" -> f = Particle.SPELL_WITCH.toString()
            }
            ParticleUtils.displayParticle(f, l, 1.0, data1, data2)
        } catch (x: Exception) {
            //x.printStackTrace();
        }
    }

    fun showEffect() {
        try {
            //GUI Bars And Stuff
            scoreCheck()
            //InfernalMob Stuff
//            val tmp = infernalList.clone()
            //TODO: ?
            for (m in infernalMobService.infernalList) {
                val mob = m.entity
                val id = mob.uniqueId
                val index = infernalMobService.idSearch(id)
                if (mob.isValid && (!mob.isDead) && (index != -1) && (mob.location.chunk.isLoaded)) {
                    //System.out.println("PE2");
                    val feet = mob.location
                    val head = mob.location
                    head.y += 1
                    if (configService.mainConfig.enableParticles) {
                        displayEffect(feet, m.effect)
                        //mob.getWorld().playEffect(feet, Effect.ENDER_SIGNAL, 1);
                        if (!EntityUtils.isSmall(mob)) {
                            displayEffect(head, m.effect)
                            //mob.getWorld().playEffect(head, Effect.ENDER_SIGNAL, 1);
                        }
                        if ((mob.type == EntityType.ENDERMAN) || (mob.type == EntityType.IRON_GOLEM)) {
                            head.y += 1
                            displayEffect(head, m.effect)
                            //mob.getWorld().playEffect(head, Effect.ENDER_SIGNAL, 1);
                        }
                    }
                    //Ability's
                    val abilityList = infernalMobService.findMobAbilities(id)
                    if (!mob.isDead) {
                        for (ability in abilityList) {
                            val rand = Random()
                            val min = 1
                            val max = 10
                            val randomNum = rand.nextInt(max - min) + min
                            if (ability == "cloaked") {
                                (mob as LivingEntity).addPotionEffect(
                                    PotionEffect(
                                        PotionEffectType.INVISIBILITY,
                                        40,
                                        1
                                    )
                                )
                            } else if (ability == "armoured") {
                                if ((mob !is Skeleton) && (mob !is Zombie)) {
                                    (mob as LivingEntity).addPotionEffect(
                                        PotionEffect(
                                            PotionEffectType.DAMAGE_RESISTANCE,
                                            40,
                                            1
                                        )
                                    )
                                }
                            } else if (ability == "oneup") {
                                if ((mob as org.bukkit.entity.Damageable).health <= 5) {
                                    val oneUpper = infernalMobService.infernalList[index]
                                    if (oneUpper!!.lives > 1) {
                                        //System.out.print("1");//-------------------------------Debug
                                        // ((org.bukkit.entity.Damageable) mob).setHealth(((org.bukkit.entity.Damageable) mob).);

                                        //System.out.print("UP!");//-------------------------------Debug
                                        //InfernalMob newMob = new InfernalMob(mob, id, mob.getWorld(), oneUpper.infernal, abilityList, 1, getEffect());
                                        //infernalList.set(index, newMob);

                                        (mob as LivingEntity).health = mob.getAttribute(Attribute.GENERIC_MAX_HEALTH)!!
                                            .baseValue
                                        oneUpper.lives -= 1
                                    }
                                }
                            } else if (ability == "sprint") {
                                (mob as LivingEntity).addPotionEffect(PotionEffect(PotionEffectType.SPEED, 40, 1))
                            } else if (ability == "molten") {
                                (mob as LivingEntity).addPotionEffect(
                                    PotionEffect(
                                        PotionEffectType.FIRE_RESISTANCE,
                                        40,
                                        1
                                    )
                                )
                            } else if (ability == "tosser") {
                                if (randomNum < 6) {
                                    val radius = 6.0
                                    val near = mob.world.players as ArrayList<Player>
                                    for (player in near) {
                                        if (player.location.distance(mob.location) <= radius) {
                                            if ((!player.isSneaking) && (player.gameMode != GameMode.CREATIVE)) {
                                                player.velocity =
                                                    mob.location.toVector().subtract(player.location.toVector())
                                            }
                                        }
                                    }
                                }
                            } else if (ability == "gravity") {
                                if (randomNum >= 9) {
                                    val radius = 10.0
                                    val near = mob.world.players as ArrayList<Player>
                                    for (player in near) {
                                        if (player.location.distance(mob.location) <= radius) {
                                            val feetBlock = player.location
                                            feetBlock.y -= 2
                                            val block = feetBlock.world.getBlockAt(feetBlock)
                                            if ((block.type != Material.AIR) && (player.gameMode != GameMode.CREATIVE)) {
                                                var amount = 6
                                                amount = configService.mainConfig.gravityLevitateLength
                                                EntityUtils.levitate(player, amount)
                                            }
                                        }
                                    }
                                }
                            } else if ((ability == "ghastly") || (ability == "necromancer")) {
                                if ((randomNum == 6) && (!mob.isDead)) {
                                    val radius = 20.0
                                    val near = mob.world.players as ArrayList<Player>
                                    for (player in near) {
                                        if ((player.location.distance(mob.location) <= radius) && (player.gameMode != GameMode.CREATIVE)) {
                                            var fb: Fireball?
                                            if (ability == "ghastly") {
                                                fb = (mob as LivingEntity).launchProjectile(
                                                    Fireball::class.java
                                                )
                                                player.world.playSound(player.location, Sound.AMBIENT_CAVE, 5f, 1f)
                                            } else {
                                                fb = (mob as LivingEntity).launchProjectile(
                                                    WitherSkull::class.java
                                                )
                                            }
                                            //Location loc1 = player.getEyeLocation();
                                            //Location loc2 = mob.getLocation();
                                            //int arrowSpeed = 1;
                                            //loc2.setY(loc2.getBlockY()+2);
                                            //loc2.setX(loc2.getBlockX()+0.5);
                                            //loc2.setZ(loc2.getBlockZ()+0.5);
                                            //Arrow ar = mob.getWorld().spawnArrow(loc2, new Vector(loc1.getX()-loc2.getX(), loc1.getY()-loc2.getY(), loc1.getZ()-loc2.getZ()), arrowSpeed, 12);
                                            //Vector vel = ar.getVelocity();
                                            //fb.setVelocity(vel);
                                            //ar.remove();
                                            EntityUtils.moveToward(fb, player.location, 0.6)
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        } catch (x: Exception) {
            x.printStackTrace()
        }
        plugin.serverTime += 1
        Bukkit.getServer().scheduler.scheduleSyncDelayedTask(
            plugin,
            { showEffect() }, 20
        )
    }

    private fun scoreCheck() {
        for (p in plugin.server.onlinePlayers) {
            gui.fixBar(p)
        }
        for ((key, value) in infernalMobService.mountList.toMutableMap()) {
            if (!key.isDead) {
                if ((value.isDead) && ((key is LivingEntity))) {
                    val fate: String = configService.mainConfig.mountFate
                    if (fate == "death") {
                        val le = key as LivingEntity?
                        le!!.damage(9.99999999E8)
                        infernalMobService.mountList.remove(key)
                    } else if (fate == "removal") {
                        key.remove()
                        plugin.logger.log(Level.INFO, "Entity remove due to Fate")
                        infernalMobService.mountList.remove(key)
                    }
                }
            } else {
                infernalMobService.mountList.remove(key)
            }
        }
    }
}