package io.github.thehrz.infernalmobs.handler

import io.github.thehrz.infernalmobs.InfernalMobs
import io.github.thehrz.infernalmobs.models.InfernalMob
import io.github.thehrz.infernalmobs.services.InfernalMobService
import io.github.thehrz.infernalmobs.utils.ItemUtils
import org.bukkit.Bukkit
import org.bukkit.Color
import org.bukkit.Location
import org.bukkit.Material
import org.bukkit.enchantments.Enchantment
import org.bukkit.entity.Entity
import org.bukkit.entity.EntityType
import org.bukkit.entity.Zombie
import org.bukkit.inventory.ItemStack
import org.bukkit.potion.PotionEffect
import org.bukkit.potion.PotionEffectType
import org.koin.core.annotation.Single
import java.util.*

@Single
class GhostHandler(val plugin: InfernalMobs, val infernalMobService: InfernalMobService) {
    fun spawnGhost(l: Location) {
        var evil = false
        if (Random().nextInt(3) == 1) {
            evil = true
        }
        val g = l.world.spawnEntity(l, EntityType.ZOMBIE) as Zombie
        g.addPotionEffect(PotionEffect(PotionEffectType.INVISIBILITY, 199999980, 1))
        g.canPickupItems = false

        val chest = ItemStack(Material.LEATHER_CHESTPLATE, 1)
        val skull: ItemStack
        if (evil) {
            skull = ItemStack(Material.WITHER_SKELETON_SKULL, 1)
            ItemUtils.dye(chest, Color.BLACK)
        } else {
            skull = ItemStack(Material.SKELETON_SKULL, 1)
            ItemUtils.dye(chest, Color.WHITE)
        }
        chest.addUnsafeEnchantment(Enchantment.PROTECTION_ENVIRONMENTAL, Random().nextInt(10) + 1)
        val m = skull.itemMeta
        m.setDisplayName("§fGhost Head")
        skull.setItemMeta(m)
        g.equipment.helmet = skull
        g.equipment.chestplate = chest
        g.equipment.helmetDropChance = 0.0f
        g.equipment.chestplateDropChance = 0.0f
        val min = 1
        val max = 5
        val rn = Random().nextInt(max - min) + min
        if (rn == 1) {
            g.equipment.setItemInMainHand(ItemStack(Material.STONE_HOE, 1))
            g.equipment.itemInMainHandDropChance = 0.0f
        }
        ghostMove(g)

        val aList = mutableListOf<String>()
        aList.add("ender")
        if (evil) {
            aList.add("necromancer")
            aList.add("withering")
            aList.add("blinding")
        } else {
            aList.add("ghastly")
            aList.add("sapper")
            aList.add("confusing")
        }
        val newMob = if (evil) {
            InfernalMob(g, g.uniqueId, false, aList, 1, "smoke:2:12")
        } else {
            InfernalMob(g, g.uniqueId, false, aList, 1, "cloud:0:8")
        }
        infernalMobService.infernalList.add(newMob)
    }

    private fun ghostMove(g: Entity) {
        if (g.isDead) {
            return
        }
        val v = g.location.direction.multiply(0.3)
        g.velocity = v

        Bukkit.getServer().scheduler.scheduleSyncDelayedTask(plugin, {
            try {
                ghostMove(g)
            } catch (ignored: Exception) {
            }
        }, 2L)
    }
}