package io.github.thehrz.infernalmobs.handler

import io.github.thehrz.infernalmobs.InfernalMobs
import io.github.thehrz.infernalmobs.services.ConfigService
import io.github.thehrz.infernalmobs.services.InfernalMobService
import io.github.thehrz.infernalmobs.utils.MathUtils
import org.bukkit.entity.Entity
import org.bukkit.entity.Player
import org.koin.core.annotation.Single

@Single
class InfernalMobHandler(private val configService: ConfigService, val plugin: InfernalMobs, private val infernalMobService: InfernalMobService) {
    private fun getAbilities(amount: Int): List<String> {
        val allAbilitiesList = configService.mainConfig.enabledAbilities.toMutableList()
        require(amount <= allAbilitiesList.size) { "Sample size cannot be greater than the list size" }
        return allAbilitiesList.shuffled().take(amount)
    }


    fun getAbilitiesAmount(e: Entity): List<String> {
        val power: Int
        if (configService.mainConfig.powerByDistance) {
            val l = e.world.spawnLocation
            var m = l.distance(e.location).toInt() / configService.mainConfig.addDistance
            if (m < 1) {
                m = 1
            }
            val add = configService.mainConfig.powerToAdd
            power = m * add
        } else {
            val min = configService.mainConfig.minpowers
            val max = configService.mainConfig.maxpowers
            power = MathUtils.rand(min, max)
        }
        return getAbilities(power)
    }
    fun removeMob(mobIndex: Int) {
        val id = infernalMobService.infernalList[mobIndex].id.toString()
        infernalMobService.infernalList.removeAt(mobIndex)
        configService.mobSaveConfig[id] = null
        configService.saveSave()
    }

}