package io.github.thehrz.infernalmobs.listeners

import io.github.thehrz.infernalmobs.InfernalMobs
import io.github.thehrz.infernalmobs.services.ConfigService
import io.github.thehrz.infernalmobs.utils.LocationUtils
import org.bukkit.Material
import org.bukkit.event.EventHandler
import org.bukkit.event.EventPriority
import org.bukkit.event.Listener
import org.bukkit.event.block.BlockBreakEvent
import org.koin.core.annotation.Single

@Single
class BlockBreakListener(
    private val plugin: InfernalMobs,
    val configService: ConfigService
) : Listener {
    @EventHandler(priority = EventPriority.HIGH)
    fun onBlockBreak(e: BlockBreakEvent) {
        if (e.block.type == Material.SPAWNER) {
            val name: String = LocationUtils.getLocationName(e.block.location)
            if (configService.mobSaveConfig.getString("infernalSpanwers.$name") != null) {
                configService.mobSaveConfig.set("infernalSpanwers.$name", null)
                configService.saveSave()
                if (e.player.isOp) {
                    e.player.sendMessage("§cYou broke an infernal mob spawner!")
                }
            }
        }
    }
}