package io.github.thehrz.infernalmobs.listeners

import io.github.thehrz.infernalmobs.InfernalMobs
import io.github.thehrz.infernalmobs.services.ConfigService
import io.github.thehrz.infernalmobs.services.InfernalMobService
import org.bukkit.entity.LivingEntity
import org.bukkit.event.EventHandler
import org.bukkit.event.EventPriority
import org.bukkit.event.Listener
import org.bukkit.event.world.ChunkLoadEvent
import org.bukkit.plugin.java.JavaPlugin
import org.koin.core.annotation.Single

@Single
class ChunkLoadListener(
    private val plugin: InfernalMobs,
    val configService: ConfigService,
    val infernalMobService: InfernalMobService
) : Listener {
    @EventHandler(priority = EventPriority.HIGH)
    fun onChunkLoad(e: ChunkLoadEvent) {
        for (ent in e.chunk.entities) {
            if (((ent is LivingEntity)) && (ent.getCustomName() != null)
                && (configService.mobSaveConfig.getString(ent.getUniqueId().toString()) != null)
            ) {
                infernalMobService.giveMobPowers(ent)
            }
        }
    }

}