package io.github.thehrz.infernalmobs.listeners

import io.github.thehrz.infernalmobs.InfernalMobs
import io.github.thehrz.infernalmobs.services.InfernalMobService
import org.bukkit.event.EventHandler
import org.bukkit.event.EventPriority
import org.bukkit.event.world.ChunkUnloadEvent
import org.koin.core.annotation.Single

@Single
class ChunkUnloadListener(private val plugin: InfernalMobs, val infernalMobService: InfernalMobService) {
    @EventHandler(priority = EventPriority.HIGH)
    fun onChunkUnload(e: ChunkUnloadEvent) {
        for (ent in e.chunk.entities) {
            val s: Int = infernalMobService.idSearch(ent.uniqueId)
            if (s != -1) {
                infernalMobService.infernalList.remove(infernalMobService.infernalList[s])
            }
        }
    }
}