package io.github.thehrz.infernalmobs.listeners

import io.github.thehrz.infernalmobs.InfernalMobs
import io.github.thehrz.infernalmobs.gui.GUI
import io.github.thehrz.infernalmobs.handler.EffectHandle
import io.github.thehrz.infernalmobs.services.InfernalMobService
import org.bukkit.entity.Arrow
import org.bukkit.entity.Entity
import org.bukkit.entity.Player
import org.bukkit.entity.Snowball
import org.bukkit.event.EventHandler
import org.bukkit.event.EventPriority
import org.bukkit.event.entity.EntityDamageByEntityEvent
import org.koin.core.annotation.Single
import java.util.logging.Level

@Single
class EntityDamageByEntityListener(
    val effectHandle: EffectHandle,
    val infernalMobService: InfernalMobService,
    val gui: GUI,
    val plugin: InfernalMobs
) {
    @EventHandler(priority = EventPriority.HIGH)
    fun onEntityAttack(event: EntityDamageByEntityEvent) {
        try {
            val attacker = event.damager
            val victim = event.entity
            val mob: Entity
            if ((attacker is Arrow)) {
                val arrow = event.damager as Arrow
                if (((arrow.shooter is Player)) && (victim !is Player)) {
                    mob = victim
                    val player = arrow.shooter as Player
                    effectHandle.doEffect(player, mob, false)
                } else if ((arrow.shooter !is Player) && ((victim is Player))) {
                    mob = arrow.shooter as Entity
                    effectHandle.doEffect(victim, mob, true)
                }
            } else if ((attacker is Snowball)) {
                val snowBall = event.damager as Snowball
                if (snowBall.shooter != null) {
                    if (((snowBall.shooter is Player)) && (victim !is Player)) {
                        mob = victim
                        val player = snowBall.shooter as Player
                        effectHandle.doEffect(player, mob, false)
                    } else if ((snowBall.shooter !is Player) && ((victim is Player))) {
                        mob = snowBall.shooter as Entity
                        effectHandle.doEffect(victim, mob, true)
                    }
                }
            } else if (((attacker is Player)) && (victim !is Player)) {
                mob = victim
                effectHandle.doEffect(attacker, mob, false)
            } else if ((attacker !is Player) && ((victim is Player))) {
                mob = attacker
                effectHandle.doEffect(victim, mob, true)
            }
            if (infernalMobService.idSearch(victim.uniqueId) != -1) {
                for (entity in victim.getNearbyEntities(64.0, 64.0, 64.0)) {
                    if ((entity is Player)) {
                        gui.fixBar(entity)
                    }
                }
            }
        } catch (e: Exception) {
            plugin.logger.log(Level.SEVERE, e.message)
            e.printStackTrace()
        }
    }
}