package io.github.thehrz.infernalmobs.listeners

import io.github.thehrz.infernalmobs.gui.GUI
import io.github.thehrz.infernalmobs.services.InfernalMobService
import org.bukkit.entity.Player
import org.bukkit.event.EventHandler
import org.bukkit.event.EventPriority
import org.bukkit.event.Listener
import org.bukkit.event.entity.EntityDamageEvent
import org.koin.core.annotation.Single


@Single
class EntityDamageListener(
    val gui: GUI,
    val infernalMobService: InfernalMobService
): Listener {
    @EventHandler(priority = EventPriority.HIGH)
    fun onEnitityDamaged(e: EntityDamageEvent) {
        val mob = e.entity
        if (infernalMobService.idSearch(mob.uniqueId) != -1) {
            for (entity in mob.getNearbyEntities(64.0, 64.0, 64.0)) {
                if ((entity is Player)) {
                    gui.fixBar(entity)
                }
            }
        }
    }
}