package io.github.thehrz.infernalmobs.listeners

import io.github.thehrz.infernalmobs.services.InfernalMobService
import org.bukkit.event.EventHandler
import org.bukkit.event.EventPriority
import org.bukkit.event.Listener
import org.bukkit.event.weather.LightningStrikeEvent
import org.bukkit.plugin.java.JavaPlugin
import org.koin.core.annotation.Single

@Single
class LightningStrikeListener(private val infernalMobService: InfernalMobService) : Listener {
    @EventHandler(priority = EventPriority.HIGH)
    fun onLightningStrike(e: LightningStrikeEvent) {
        for (m in e.lightning.getNearbyEntities(6.0, 6.0, 6.0)) {
            if (infernalMobService.idSearch(m.uniqueId) != -1) {
                e.isCancelled = true
                break
            }
        }
    }
}