package io.github.thehrz.infernalmobs.listeners

import io.github.thehrz.infernalmobs.commands.Command
import io.github.thehrz.infernalmobs.services.ConfigService
import io.github.thehrz.infernalmobs.services.InfernalMobService
import org.bukkit.attribute.Attribute
import org.bukkit.entity.LivingEntity
import org.bukkit.event.EventHandler
import org.bukkit.event.EventPriority
import org.bukkit.event.Listener
import org.bukkit.event.player.PlayerInteractEntityEvent
import org.koin.core.annotation.Single

@Single
class PlayerInteractEntityListener(
    val configService: ConfigService,
    val infernalMobService: InfernalMobService,
    val command: Command
) : Listener {
    @EventHandler(priority = EventPriority.HIGH)
    fun onPlayerInteractEntity(e: PlayerInteractEntityEvent) {
        val p = e.player
        val ent = e.rightClicked
        if (command.errorList.contains(p)) {
            command.errorList.remove(p)
            p.sendMessage("§6Error report:")

            var name: String? = ""
            try {
                name = ent.customName
            } catch (ignored: Exception) {
            }
            p.sendMessage("§eName: §f$name")
            p.sendMessage("§eSaved: §f" + configService.mobSaveConfig.getString(ent.uniqueId.toString()))
            p.sendMessage(
                "§eHealth: §f" + (ent as LivingEntity).getAttribute(Attribute.GENERIC_MAX_HEALTH)!!
                    .value
            )
            p.sendMessage("§eInfernal: §f" + infernalMobService.idSearch(ent.getUniqueId()))
        }
    }
}