package io.github.thehrz.infernalmobs.listeners

import io.github.thehrz.infernalmobs.gui.GUI
import io.github.thehrz.infernalmobs.InfernalMobs
import io.github.thehrz.infernalmobs.services.InfernalMobService
import io.github.thehrz.infernalmobs.utils.EntityUtils
import io.github.thehrz.infernalmobs.utils.LocationUtils
import io.github.thehrz.infernalmobs.utils.MathUtils
import org.bukkit.Bukkit
import org.bukkit.Location
import org.bukkit.Material
import org.bukkit.entity.Entity
import org.bukkit.event.EventHandler
import org.bukkit.event.EventPriority
import org.bukkit.event.Listener
import org.bukkit.event.player.PlayerInteractEvent
import org.bukkit.inventory.ItemStack
import org.koin.core.annotation.Single
import kotlin.math.acos
import kotlin.math.atan2
import kotlin.math.cos
import kotlin.math.sin

@Single
class PlayerInteractListener(val plugin: InfernalMobs, val infernalMobService: InfernalMobService) : Listener {

    @EventHandler(priority = EventPriority.HIGH)
    fun onPlayerInteract(e: PlayerInteractEvent) {
        val p = e.player
        try {
            val s: ItemStack = plugin.diviningStaff
            if (p.inventory.itemInMainHand.itemMeta.displayName == s.itemMeta.displayName) {
                val b = infernalMobService.getNearbyBoss(p)
                //Make Look At
                if (b != null) {
                    //Take Powder
                    var took = false
                    for (i in p.inventory) if (i != null && i.type == Material.BLAZE_POWDER) {
                        if (i.amount == 1) {
                            p.inventory.remove(i)
                        } else i.amount -= 1
                        took = true
                        break
                    }
                    if (!took) {
                        p.sendMessage("§cYou need blaze powder to use this!")
                        return
                    }
                    //Change Looking
                    val source = b
                    val target: Entity = p

                    val direction = EntityUtils.getVector(target).subtract(EntityUtils.getVector(source)).normalize()
                    val x = direction.x
                    val y = direction.y
                    val z = direction.z

                    // Now change the angle
                    val changed = target.location.clone()
                    changed.yaw = 180 - MathUtils.toDegree(atan2(x, z))
                    changed.pitch = 90 - MathUtils.toDegree(acos(y))
                    target.teleport(changed)
                    //Beam
                    Bukkit.getServer().scheduler.scheduleSyncDelayedTask(
                        plugin,
                        { //Shoot Beam
                            val eyeLoc = p.eyeLocation
                            val px = eyeLoc.x
                            val py = eyeLoc.y
                            val pz = eyeLoc.z
                            val yaw = Math.toRadians((eyeLoc.yaw + 90).toDouble())
                            val pitch = Math.toRadians((eyeLoc.pitch + 90).toDouble())
                            val x = sin(pitch) * cos(yaw)
                            val y = sin(pitch) * sin(yaw)
                            val z = cos(pitch)
                            for (j in 1..10) {
                                for (i in 1..10) {
                                    val loc = Location(p.world, px + (i * x), py + (i * z), pz + (i * y))
                                    LocationUtils.beamParticles(loc)
                                }
                            }
                        }, 5
                    )
                }
            }
        } catch (_: Exception) {
        }
    }
}