package io.github.thehrz.infernalmobs.listeners

import io.github.thehrz.infernalmobs.handler.EffectHandle
import io.github.thehrz.infernalmobs.handler.LootHandler
import io.github.thehrz.infernalmobs.services.ConfigService
import org.bukkit.configuration.file.YamlConfiguration
import org.bukkit.event.EventHandler
import org.bukkit.event.EventPriority
import org.bukkit.event.Listener
import org.bukkit.event.player.PlayerItemConsumeEvent
import org.koin.core.annotation.Single

@Single
class PlayerItemConsumeListener(
    val lootHandler: LootHandler,
    val effectHandle: EffectHandle,
    val configService: ConfigService
) : Listener {
    @EventHandler(priority = EventPriority.HIGH)
    fun onPlayerItemConsumeEvent(e: PlayerItemConsumeEvent) {
        val p = e.player
        val check = e.item
        if (configService.lootConfig.getString("consumeEffects") != null) for (id in configService.lootConfig.getConfigurationSection("consumeEffects")!!
            .getKeys(false)) if (configService.lootConfig.getString("consumeEffects.$id.requiredItem") != null) {
            val neededItem = lootHandler.getItem(
                configService.lootConfig.getInt(
                    "consumeEffects.$id.requiredItem"
                )
            )
            if (neededItem != null && (neededItem.itemMeta != null) && (check.itemMeta.displayName == neededItem.itemMeta.displayName)) if (check.type == neededItem.type)
                effectHandle.applyEatEffects(p, id.toInt())
        }
    }
}