package io.github.thehrz.infernalmobs.tasks

import org.bukkit.entity.Arrow
import org.bukkit.entity.LivingEntity
import org.bukkit.plugin.Plugin
import org.bukkit.scheduler.BukkitRunnable
import org.bukkit.util.Vector

internal class ArrowHomingTask(
    private val arrow: Arrow,
    private val target: LivingEntity,
    plugin: Plugin
) : BukkitRunnable() {
    init {
        runTaskTimer(plugin, 1L, 1L)
    }

    override fun run() {
        try {
            val speed = arrow.velocity.length()
            if ((arrow.isOnGround) || (arrow.isDead) || (target.isDead)) {
                cancel()
                return
            }

            val toTarget = target.location.clone().add(Vector(0.0, 0.5, 0.0)).subtract(
                arrow.location
            ).toVector()

            val dirVelocity = arrow.velocity.clone().normalize()
            val dirToTarget = toTarget.clone().normalize()
            val angle = dirVelocity.angle(dirToTarget).toDouble()

            val newSpeed = 0.9 * speed + 0.14

            val newVelocity: Vector
            if (angle < 0.12) {
                newVelocity = dirVelocity.clone().multiply(newSpeed)
            } else {
                val newDir =
                    dirVelocity.clone().multiply((angle - 0.12) / angle).add(dirToTarget.clone().multiply(0.12 / angle))
                newDir.normalize()
                newVelocity = newDir.clone().multiply(newSpeed)
            }

            arrow.velocity = newVelocity.add(Vector(0.0, 0.03, 0.0))
        } catch (ignored: Exception) {
        }
    }
}