package io.github.thehrz.infernalmobs.utils

import org.bukkit.Location
import org.bukkit.Material
import org.bukkit.block.Block
import java.util.*
import kotlin.math.cos
import kotlin.math.sin

object BlockUtils {
    fun blockNear(l: Location, mat: Material, radius: Int): Block? {
        val xTmp = l.x
        val yTmp = l.y
        val zTmp = l.z
        val finalX = Math.round(xTmp).toInt()
        val finalY = Math.round(yTmp).toInt()
        val finalZ = Math.round(zTmp).toInt()
        for (x in finalX - radius..(finalX + radius)) {
            for (y in finalY - radius..(finalY + radius)) {
                for (z in finalZ - radius..(finalZ + radius)) {
                    val loc = Location(l.world, x.toDouble(), y.toDouble(), z.toDouble())
                    val block = loc.block
                    if (block.type == mat) {
                        return block
                    }
                }
            }
        }
        return null
    }

    fun getSphere(block1: Block): List<Block> {
        val blocks = LinkedList<Block>()
        val xi = block1.location.x + 0.5
        val yi = block1.location.y + 0.5
        val zi = block1.location.z + 0.5
        for (v1 in 0..90) {
            val y = sin(0.017453292519943295 * v1) * 4
            var r = cos(0.017453292519943295 * v1) * 4
            if (v1 == 90) {
                r = 0.0
            }
            for (v2 in 0..90) {
                val x = sin(0.017453292519943295 * v2) * r
                var z = cos(0.017453292519943295 * v2) * r
                if (v2 == 90) {
                    z = 0.0
                }
                if (!blocks.contains(
                        block1.world.getBlockAt(
                            (xi + x).toInt(),
                            (yi + y).toInt(),
                            (zi + z).toInt()
                        )
                    )
                ) {
                    blocks.add(block1.world.getBlockAt((xi + x).toInt(), (yi + y).toInt(), (zi + z).toInt()))
                }
                if (!blocks.contains(
                        block1.world.getBlockAt(
                            (xi - x).toInt(),
                            (yi + y).toInt(),
                            (zi + z).toInt()
                        )
                    )
                ) {
                    blocks.add(block1.world.getBlockAt((xi - x).toInt(), (yi + y).toInt(), (zi + z).toInt()))
                }
                if (!blocks.contains(
                        block1.world.getBlockAt(
                            (xi + x).toInt(),
                            (yi - y).toInt(),
                            (zi + z).toInt()
                        )
                    )
                ) {
                    blocks.add(block1.world.getBlockAt((xi + x).toInt(), (yi - y).toInt(), (zi + z).toInt()))
                }
                if (!blocks.contains(
                        block1.world.getBlockAt(
                            (xi + x).toInt(),
                            (yi + y).toInt(),
                            (zi - z).toInt()
                        )
                    )
                ) {
                    blocks.add(block1.world.getBlockAt((xi + x).toInt(), (yi + y).toInt(), (zi - z).toInt()))
                }
                if (!blocks.contains(
                        block1.world.getBlockAt(
                            (xi - x).toInt(),
                            (yi - y).toInt(),
                            (zi - z).toInt()
                        )
                    )
                ) {
                    blocks.add(block1.world.getBlockAt((xi - x).toInt(), (yi - y).toInt(), (zi - z).toInt()))
                }
                if (!blocks.contains(
                        block1.world.getBlockAt(
                            (xi + x).toInt(),
                            (yi - y).toInt(),
                            (zi - z).toInt()
                        )
                    )
                ) {
                    blocks.add(block1.world.getBlockAt((xi + x).toInt(), (yi - y).toInt(), (zi - z).toInt()))
                }
                if (!blocks.contains(
                        block1.world.getBlockAt(
                            (xi - x).toInt(),
                            (yi + y).toInt(),
                            (zi - z).toInt()
                        )
                    )
                ) {
                    blocks.add(block1.world.getBlockAt((xi - x).toInt(), (yi + y).toInt(), (zi - z).toInt()))
                }
                if (!blocks.contains(
                        block1.world.getBlockAt(
                            (xi - x).toInt(),
                            (yi - y).toInt(),
                            (zi + z).toInt()
                        )
                    )
                ) {
                    blocks.add(block1.world.getBlockAt((xi - x).toInt(), (yi - y).toInt(), (zi + z).toInt()))
                }
            }
        }
        return blocks
    }

}