package io.github.thehrz.infernalmobs.utils

import org.bukkit.ChatColor
import org.bukkit.Color
import org.bukkit.Material
import org.bukkit.block.Banner
import org.bukkit.configuration.file.FileConfiguration
import org.bukkit.enchantments.Enchantment
import org.bukkit.inventory.ItemStack
import org.bukkit.inventory.meta.*
import java.io.IOException
import java.util.*

object ItemUtils {
    fun getItem(mat: Material, name: String?, amount: Int, loreList: List<String>?): ItemStack {
        val item = ItemStack(mat, amount)
        val m = item.itemMeta
        if (name != null) m.setDisplayName(name)
        if (loreList != null) m.lore = loreList
        item.setItemMeta(m)
        return item
    }

    fun dye(item: ItemStack, color: Color) {
        val meta = item.itemMeta as LeatherArmorMeta
        meta.setColor(color)
        item.setItemMeta(meta)
    }

    fun isArmor(s: ItemStack): Boolean {
        val t = s.type.toString().lowercase(Locale.getDefault())
        return t.contains("helm") || t.contains("plate") || t.contains("leg") || t.contains("boot")
    }

    fun prosessLootName(name: String, stack: ItemStack): String {
        var name = name
        name = ChatColor.translateAlternateColorCodes('&', name)
        var itemName = stack.type.name
        itemName = itemName.replace("_", " ")
        itemName = itemName.lowercase(Locale.getDefault())
        name = name.replace("<itemName>", itemName)
        return name
    }

    fun getMaterial(s: String?): Material {
        return Material.valueOf(s!!)
    }


}