package io.github.thehrz.infernalmobs.utils

import io.github.thehrz.infernalmobs.InfernalMobs
import org.bukkit.Bukkit
import org.bukkit.Location
import org.bukkit.Material
import org.bukkit.Particle

object LocationUtils {
    fun beamParticles(loc: Location) {
        val speed = -1
        val amount = 1
        val r = 0.0
        ParticleUtils.displayParticle(
            Particle.DRIP_LAVA.toString(),
            loc.world,
            loc.x,
            loc.y,
            loc.z,
            r,
            speed,
            amount
        )
    }

    fun getLocationName(l: Location): String {
        return (l.x.toString() + "." + l.y + "." + l.z + l.world.name).replace(".", "")
    }

    fun getArea(l: Location, r: Double, t: Double): MutableList<Location> {
        val ll = mutableListOf<Location>()
        var x = l.x - r
        while (x < l.x + r) {
            var y = l.y - r
            while (y < l.y + r) {
                var z = l.z - r
                while (z < l.z + r) {
                    ll.add(Location(l.world, x, y, z))
                    z += t
                }
                y += t
            }
            x += t
        }
        return ll
    }

    fun setAir(block: Location, time: Int) {
        Bukkit.getServer().scheduler.scheduleSyncDelayedTask(
            InfernalMobs.instance,
            {
                if (block.block.type == Material.COBWEB) {
                    block.block.type = Material.AIR
                }
            }, (time * 20).toLong()
        )
    }
}